package com.inca.npbusi.saset.bms_sa_set;

import com.inca.np.auth.ClientUserManager;
import com.inca.np.communicate.ClientRequest;
import com.inca.np.communicate.DataCommand;
import com.inca.np.communicate.ParamCommand;
import com.inca.np.communicate.ServerResponse;
import com.inca.np.communicate.StringCommand;
import com.inca.np.demo.communicate.RemotesqlHelper;
import com.inca.np.env.Configer;
import com.inca.np.gui.control.CFrame;
import com.inca.np.gui.control.CHovBase;
import com.inca.np.gui.control.COtherquerycontrol;
import com.inca.np.gui.control.CTable;
import com.inca.np.gui.control.DBColumnDisplayInfo;
import com.inca.np.gui.control.DBTableModel;
import com.inca.np.gui.mde.CDetailModel;
import com.inca.np.gui.mde.CMasterModel;
import com.inca.np.gui.mde.CMdeModel;
import com.inca.np.util.DecimalHelper;
import com.inca.np.util.SendHelper;
import com.inca.npbusi.dataimport.ExcelFilter;
import com.inca.npbusi.dataimport.ImpHelper;
import com.inca.npbusi.saset.bms_sa_set.bms_sa_set_confirm.Bms_sa_set_confirm_hov;
import com.inca.npbusi.saset.bms_sa_set.sa_tick.Bms_sa_tick_hov;
import com.inca.npbusi.saset.bms_sa_set.sa_tick_mde.Bms_sa_tick_mde_hov;
import com.inca.npx.mde.CMdeModelAp;
import com.inca.npx.ste.Apinfo;
import com.inca.pubsrv.CreateInvnoDialog;
import com.inca.pubsrv.Entrychose;
import com.inca.pubsrv.NpSaDbHelper;
import com.inca.pubsrv.mpcsprodHelper;
import com.inca.pubsrv.hov.bms_sa_inv_info_hov.Bms_sa_inv_info_hov;
import java.awt.Frame;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.math.BigDecimal;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Vector;
import java.util.regex.Pattern;
import javax.swing.JFileChooser;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPopupMenu;
import org.apache.poi.hssf.usermodel.HSSFCell;
import org.apache.poi.hssf.usermodel.HSSFDateUtil;
import org.apache.poi.hssf.usermodel.HSSFRow;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;

public class Bms_sa_set_mde extends CMdeModelAp {
   private String a = "";
   private String b = "";
   private boolean c = false;
   private CHovBase d = null;

   public String getEntryid() {
      return this.a;
   }

   public void setEntryid(String var1) {
      this.a = var1;
   }

   public String getEntryname() {
      return this.b;
   }

   public void setEntryname(String var1) {
      this.b = var1;
   }

   public Bms_sa_set_mde(CFrame var1, String var2) {
      super(var1, var2);
      this.setEntryid(ClientUserManager.getCurrentUser().getEntryid());
      this.setEntryname(ClientUserManager.getCurrentUser().getEntryname());
   }

   protected CMasterModel createMastermodel() {
      return new Bms_sa_set_master(this.frame, this);
   }

   protected CDetailModel createDetailmodel() {
      return new Bms_sa_set_detail(this.frame, this);
   }

   public String getMasterRelatecolname() {
      return "sasettleid";
   }

   public String getDetailRelatecolname() {
      return "sasettleid";
   }

   public String getSaveCommandString() {
      return "Bms_sa_set_mde.保存销售结算单";
   }

   public Vector<Apinfo> getParamapinfos() {
      Vector var1;
      (var1 = new Vector()).add(new Apinfo("自动确定结算单", ""));
      var1.add(new Apinfo("确定后准许出库配货", ""));
      var1.add(new Apinfo("确定后自动出库配货", ""));
      var1.add(new Apinfo("确定后自动记保管账", ""));
      var1.add(new Apinfo("清除导出标志", ""));
      var1.add(new Apinfo("禁止确定", ""));
      var1.add(new Apinfo("禁止回退确定", ""));
      var1.add(new Apinfo("禁止作废", ""));
      var1.add(new Apinfo("勾兑模式", ""));
      if (mpcsprodHelper.getSysProdConfig(ClientUserManager.getCurrentUser().getEntryid(), "prod202003").equals("1")) {
         var1.add(new Apinfo("回执确认", ""));
         var1.add(new Apinfo("取消回执", ""));
      }

      var1.add(new Apinfo("发票号是否自动递增生成", ""));
      return var1;
   }

   protected int on_actionPerformed(String var1) {
      Bms_sa_set_mde var2;
      int var3;
      String var8;
      String var26;
      String var34;
      if (var1.equals("由销售发货单生成")) {
         var2 = this;
         if ((var3 = this.getMasterModel().getRow()) < 0) {
            this.errorMessage("错误", "请手工新增总单后再由销售发货单生成！");
         } else if (!this.getMasterModel().getItemValue(var3, "usestatus").equals("2")) {
            this.errorMessage("错误", "只有临时状态的总单记录才能由销售发货单生成！");
         } else {
            if (this.getMasterModel().getdbStatus(var3) == 0) {
               this.getMasterModel().setdbStatus(var3, 2);
            }

            if ((var26 = this.getMasterModel().getItemValue(var3, "customid")) != null && !var26.equals("")) {
               String var33;
               if ((var33 = this.getMasterModel().getItemValue(var3, "sa_mode")) != null && !var33.equals("")) {
                  var34 = this.getMasterModel().getDBtableModel().getTmppkid(0);
                  var8 = this.getApvalue("勾兑模式");
                  a var27;
                  if ("1".equals(var8)) {
                     var27 = this.doTickMde(var3, var26, var33);
                  } else {
                     var27 = this.doTickSte(var3, var26, var33);
                  }

                  while(var27.b) {
                     if (!var27.c) {
                        var27 = var2.doTickMde(var3, var26, var33);
                     } else {
                        var27 = var2.doTickSte(var3, var26, var33);
                     }
                  }

                  if (var27.a != null) {
                     if (var27.c) {
                        CMdeModel var36 = ((Bms_sa_tick_mde_hov)var2.d).getMdemodel();
                        ((Bms_sa_set_detail)var2.getDetailModel()).gensasettledtl(var36, var34);
                        var2.getDetailModel().tableChanged();
                        var2.getMasterModel().tableChanged();
                     } else {
                        CTable var37 = ((Bms_sa_tick_hov)var2.d).getTable();
                        ((Bms_sa_set_master)var2.getMasterModel()).gensasettle(var37);
                        ((Bms_sa_set_detail)var2.getDetailModel()).gensasettledtl(var37, var34);
                        var2.getDetailModel().tableChanged();
                        var2.getMasterModel().tableChanged();
                     }

                     var2.getDetailModel().setItemValue(var2.getDetailModel().getRowCount() - 1, "invalidflag", "0");
                     var2.getDetailModel().setItemValue(var2.getDetailModel().getRowCount() - 1, "correctflag", "0");
                     var2.getDetailModel().setItemValue(var2.getDetailModel().getRowCount() - 1, "taxflag", "0");
                  }
               } else {
                  this.errorMessage("错误", "请设置销售模式后再由销售发货单生成！");
               }
            } else {
               this.errorMessage("错误", "请选择客户后再由销售发货单生成！");
            }
         }

         return 0;
      } else if (var1.equals("确定")) {
         if ("1".equals(this.getApvalue("禁止确定"))) {
            this.infoMessage("提示", "对不起，您没有权限执行该操作！");
            return -1;
         } else {
            this.a(true);
            return 0;
         }
      } else {
         DBColumnDisplayInfo var5;
         DataCommand var21;
         String var22;
         if (var1.equals("回退确定")) {
            if ("1".equals(this.getApvalue("禁止回退确定"))) {
               this.infoMessage("提示", "对不起，您没有权限执行该操作！");
               return -1;
            } else {
               var2 = this;
               if (this.getMasterModel().getRow() >= 0 && this.getMasterModel().getRow() != this.getMasterModel().getDBtableModel().getRowCount()) {
                  for(var3 = 0; var3 < var2.getMasterModel().getRowCount(); ++var3) {
                     if (var2.getMasterModel().getdbStatus(var3) != 0) {
                        var2.errorMessage("错误", "没有保存不能回退确定,请先保存!");
                        return 0;
                     }
                  }

                  int[] var23;
                  if ((var23 = var2.getMasterModel().getTable().getSelectedRows()).length <= 0) {
                     var2.infoMessage("", "请先选择需要确定的结算单！");
                  } else if (var2.getDetailModel().getRow() >= 0 && var2.getDetailModel().getRow() != var2.getDetailModel().getDBtableModel().getRowCount()) {
                     int[] var24;
                     int var28 = (var24 = var2.getDetailModel().getTable().getSelectedRows()).length;
                     if (var2.getDetailModel().getTable().getSelectedRow() == var2.getDetailModel().getTable().getRowCount() - 1) {
                        var2.errorMessage("错误", "选中行错误,请重新选择!");
                     } else {
                        if (var24[var24.length - 1] == var2.getDetailModel().getRowCount()) {
                           --var28;
                        }

                        int var30 = 0;

                        while(true) {
                           if (var30 >= var28) {
                              DBTableModel var31 = d();

                              for(int var38 = 0; var38 < var23.length; ++var38) {
                                 var8 = var2.getMasterModel().getItemValue(var23[var38], "sasettleid");
                                 var22 = var2.getMasterModel().getItemValue(var2.getMasterModel().getRow(), "usestatus");
                                 if (!"1".equals(var22)) {
                                    var2.errorMessage("错误", "结算单ID为" + var8 + "的结算单不是正式状态，不能回退确定！");
                                    return 0;
                                 }

                                 RemotesqlHelper var32 = new RemotesqlHelper();
                                 var1 = "select a.sasettleid from bms_sa_settle_dtl a,bms_sa_doctoset b ,bms_sa_dtl c,bms_sa_doc d  where a.sasettledtlid=b.sasettledtlid and b.salesdtlid=c.salesdtlid  and c.salesid=d.salesid and nvl(d.fix_mode,0)=2 and nvl(c.stioflag,0)=1 and nvl(d.satypeid,0) = 1and a.sasettleid=" + var8 + " ";

                                 try {
                                    if (var32.doSelect(var1, 0, 1).getRowCount() > 0) {
                                       var2.infoMessage("提示！", "结算单ID为" + var8 + "的结算单对应的销售单为先结后配模式，并且已出库记账，不能回退确定！");
                                       return 0;
                                    }
                                 } catch (Exception var18) {
                                    var2.errorMessage("错误", var18.getMessage());
                                    var18.printStackTrace();
                                    return 0;
                                 }

                                 var31.appendRow();
                                 var31.setItemValue(var31.getRowCount() - 1, "sasettleid", var8);
                              }

                              ClientRequest var40 = new ClientRequest();
                              StringCommand var39 = new StringCommand("Bms_sa_set_mde.销售结算单回退确定");
                              (var21 = new DataCommand()).setDbmodel(var31);
                              var40.addCommand(var39);
                              var40.addCommand(var21);
                              var40.addCommand(new StringCommand(var2.getEntryid()));
                              var2.setWaitCursor();
                              var5 = null;

                              try {
                                 try {
                                    ServerResponse var35 = SendHelper.sendRequest(var40);
                                    var2.a(var35, "回退确定", 2, 5, 1);
                                 } catch (Exception var14) {
                                    var2.errorMessage("错误", "回退确定不成功原因:" + var14.getMessage());
                                    var14.printStackTrace();
                                 }
                                 break;
                              } finally {
                                 var2.setDefaultCursor();
                              }
                           }

                           if (var2.getDetailModel().getdbStatus(var24[var30]) != 0) {
                              var2.errorMessage("错误", "第" + (var24[var30] + 1) + "行细单没有保存不能回退,请先保存!");
                              break;
                           }

                           var34 = var2.getDetailModel().getItemValue(var24[var30], "correctflag");
                           if ("".equals(var34)) {
                              var34 = "0";
                           }

                           if (!var34.equals("0")) {
                              var2.errorMessage("错误", "原单、冲单、新单不允许回退，请检查第" + (var24[var30] + 1) + "行细单！");
                              break;
                           }

                           ++var30;
                        }
                     }
                  }
               }

               return 0;
            }
         } else if (var1.equals("作废")) {
            if ("1".equals(this.getApvalue("禁止作废"))) {
               this.infoMessage("提示", "对不起，您没有权限执行该操作！");
               return -1;
            } else {
               this.c();
               return 0;
            }
         } else if (var1.equals("生成发票")) {
            this.b();
            return 0;
         } else if (var1.equals("导出金穗")) {
            createMenu(this, false).show(this.frame.getRootPane().getContentPane(), 450, 43);
            return 0;
         } else if (var1.equals("切换独立单元")) {
            if (this.mastermodel.getModifiedDbmodel().getRowCount() > 0) {
               this.infoMessage("提示", "有尚未保存的数据，请先作保存！");
               return -1;
            } else {
               if (Entrychose.setUserEntryInfo(this.frame)) {
                  this.setEntryid(ClientUserManager.getCurrentUser().getEntryid());
                  this.setEntryname(ClientUserManager.getCurrentUser().getEntryname());
                  this.getMasterModel().doRetrieve("1=2");
               }

               return 0;
            }
         } else if (var1.equals("清除导出标志")) {
            if (this.getApvalue("清除导出标志").equals("1")) {
               createMenu(this, true).show(this.frame.getRootPane().getContentPane(), 550, 43);
               return 0;
            } else {
               this.infoMessage("提示", "您没有权限执行该操作！");
               return -1;
            }
         } else {
            if (var1.equals("doc_doClear")) {
               this.b("1");
            } else if (var1.equals("dtl_doClear")) {
               this.b("0");
            } else if (var1.equals("doc_doImp")) {
               if (this.getMasterModel().getRowCount() <= 0) {
                  this.infoMessage("提示", "请选择结算总单导出金穗！");
                  return -1;
               }

               this.a("1");
            } else if (var1.equals("dtl_doImp")) {
               if (this.getMasterModel().getRowCount() <= 0) {
                  this.infoMessage("提示", "请选择结算细单导出金穗！");
                  return -1;
               }

               this.a("0");
            } else {
               if (var1.equals("回执确认")) {
                  if (!"1".equals(this.getApvalue("回执确认"))) {
                     this.infoMessage("提示", "对不起，您没有权限执行该操作！");
                     return -1;
                  }

                  var3 = this.getMasterModel().getRow();
                  var22 = this.getMasterModel().getItemValue(var3, "receiptstatus");
                  var26 = ClientUserManager.getCurrentUser().getUserid();
                  Date var29 = new Date();
                  var8 = (new SimpleDateFormat("yyyy-MM-dd")).format(var29);
                  if (!var22.equals("1")) {
                     this.getMasterModel().setItemValue(var3, "receiptstatus", "1");
                     this.getMasterModel().setItemValue(var3, "receiptmanid", var26);
                     this.getMasterModel().setItemValue(var3, "receiptdate", var8);
                  }

                  this.doSaveSlient();
                  return 0;
               }

               if (var1.equals("取消回执")) {
                  if (!"1".equals(this.getApvalue("取消回执"))) {
                     this.infoMessage("提示", "对不起，您没有权限执行该操作！");
                     return -1;
                  }

                  var3 = this.getMasterModel().getRow();
                  if (this.getMasterModel().getItemValue(var3, "receiptstatus").equals("1")) {
                     this.getMasterModel().setItemValue(var3, "receiptstatus", "0");
                     this.getMasterModel().setItemValue(var3, "receiptmanid", "");
                     this.getMasterModel().setItemValue(var3, "receiptdate", "");
                  }

                  this.doSaveSlient();
               } else if (var1.equals("红冲") && JOptionPane.showConfirmDialog(this.frame, "将生成负的临时状态的销售结算单。是否继续？", "提示", 0) == 0) {
                  Vector var4 = new Vector();
                  var5 = new DBColumnDisplayInfo("sasettleid", "number");
                  var4.add(var5);
                  var5 = new DBColumnDisplayInfo("inputmanid", "number");
                  var4.add(var5);
                  DBTableModel var19 = new DBTableModel(var4);
                  var21 = new DataCommand();
                  ParamCommand var25;
                  (var25 = new ParamCommand()).addParam("sasettleid", this.mastermodel.getItemValue(this.mastermodel.getRow(), "sasettleid"));
                  var25.addParam("inputmanid", this.mastermodel.getItemValue(this.mastermodel.getRow(), "inputmanid"));
                  var21.setDbmodel(var19);
                  ClientRequest var6;
                  (var6 = new ClientRequest()).addCommand(new StringCommand("Bms_sa_set_mde.红冲"));
                  var6.addCommand(var25);
                  var6.addCommand(var21);
                  ServerResponse var7 = null;

                  try {
                     var7 = SendHelper.sendRequest(var6);
                  } catch (Exception var17) {
                     var17.printStackTrace();
                  }

                  if ((var8 = ((StringCommand)var7.commandAt(0)).getString()).startsWith("+OK")) {
                     this.setDefaultCursor();
                     this.infoMessage("提示", "红冲成功! ");
                  } else {
                     this.setDefaultCursor();
                     this.infoMessage("错误", "红冲不成功，原因：" + var8);
                  }
               }
            }

            if (var1.equals("发票模板导出")) {
               var2 = this;
               String[] var20 = new String[]{"销售结算细单ID*", "发票日期(yyyy-mm-dd)*", "发票号", "发票编码"};
               var22 = "销售发票导入模板";

               try {
                  ImpHelper.createExcel(var20, var22);
                  var2.infoMessage("提示", "EXCEL模板生成完成，存放路径：C:/DatabaseExcel/");
               } catch (Exception var16) {
                  var16.printStackTrace();
                  this.errorMessage("错误", "生成EXCEL模板失败：" + var16.getMessage());
               }
            }

            if (var1.equals("发票细单导入")) {
               this.a();
            }

            return super.on_actionPerformed(var1);
         }
      }
   }

   private void a() {
      if (this.getModifiedRowCount() > 0) {
         this.infoMessage("提示", "请保存当前操作后，再导入EXCEL文件！");
      } else {
         try {
            Configer var1;
            String var2;
            if ((var2 = (String)(var1 = new Configer(new File("conf/EXCEL.properties"))).get("LASTIMPEXCELDIR")) == null || "".equals(var2)) {
               var2 = "./";
            }

            JFileChooser var3;
            (var3 = new JFileChooser("选择导入文件")).setCurrentDirectory(new File(var2));
            var3.setFileFilter(new ExcelFilter());
            if (var3.showOpenDialog(this.frame) == 0) {
               File var30 = var3.getSelectedFile();
               var1.put("LASTIMPEXCELDIR", var30.getAbsolutePath());
               var1.saveConfigfile();

               HSSFWorkbook var28;
               try {
                  var28 = new HSSFWorkbook(new FileInputStream(var30));
               } catch (Exception var24) {
                  throw new Exception("打开文件：" + var30.getName() + "失败");
               }

               HSSFSheet var29 = var28.getSheetAt(0);
               Vector var31 = new Vector();
               DBColumnDisplayInfo var32 = new DBColumnDisplayInfo("sasettledtlid", "number");
               var31.add(var32);
               var32 = new DBColumnDisplayInfo("invdate", "date");
               var31.add(var32);
               var32 = new DBColumnDisplayInfo("invno", "varchar");
               var31.add(var32);
               var32 = new DBColumnDisplayInfo("invcode", "varchar");
               var31.add(var32);
               DBTableModel var33 = new DBTableModel(var31);
               HashMap var34;
               (var34 = new HashMap()).put("0", "sasettledtlid");
               var34.put("1", "invdate");
               var34.put("2", "invno");
               var34.put("3", "invcode");
               HSSFRow var4 = null;
               String var5 = null;
               String var6 = "";
               HSSFCell var7 = null;
               SimpleDateFormat var8 = new SimpleDateFormat("yyyy-MM-dd");

               for(int var9 = 1; var9 < var29.getPhysicalNumberOfRows(); ++var9) {
                  var4 = var29.getRow(var9);
                  var33.appendRow();

                  for(int var10 = 0; var10 < var4.getLastCellNum(); ++var10) {
                     if ((var7 = var4.getCell(var10)) != null) {
                        var5 = (String)var34.get(Integer.toString(var10));
                        if (!"".equals(var5) && var5 != null) {
                           if (var7.getCellType() == 0) {
                              if (HSSFDateUtil.isCellDateFormatted(var7)) {
                                 var6 = var8.format(var7.getDateCellValue());
                              } else {
                                 double var18;
                                 if ((var18 = var7.getNumericCellValue()) % 1.0 == 0.0) {
                                    var6 = (new DecimalFormat("#")).format(var18);
                                 } else {
                                    var6 = (new DecimalFormat("#.##########")).format(var18);
                                 }
                              }
                           } else if (var7.getCellType() == 2) {
                              var6 = "";
                           } else if (var7.getCellType() == 1) {
                              var6 = var7.getRichStringCellValue().getString();
                           } else if (var7.getCellType() == 3) {
                              var6 = "";
                           } else if (var7.getCellType() == 5) {
                              var6 = "";
                           } else if (var7.getCellType() == 4) {
                              var6 = "";
                           }

                           var6 = this.replace(var6);
                           var33.setItemValue(var9 - 1, var5, var6);
                        }
                     }
                  }
               }

               ClientRequest var36 = new ClientRequest();
               StringCommand var37 = new StringCommand("Bms_sa_set_mde.销售发票导入");
               DataCommand var35;
               (var35 = new DataCommand()).setDbmodel(var33);
               var36.addCommand(var37);
               var36.addCommand(var35);
               this.setWaitCursor();
               Object var38 = null;

               try {
                  String var19;
                  if ((var19 = SendHelper.sendRequest(var36).getCommand()).startsWith("+OK")) {
                     this.infoMessage("提示", "导入成功，请手动刷新！");
                  } else {
                     this.errorMessage("错误", var19);
                  }

                  return;
               } catch (Exception var25) {
                  this.errorMessage("错误", "导入不成功原因:" + var25.getMessage());
                  var25.printStackTrace();
               } finally {
                  this.setDefaultCursor();
               }

            }
         } catch (Exception var27) {
            this.errorMessage("错误", var27.getMessage());
         }
      }
   }

   public String replace(String var1) {
      return var1 == null ? "" : Pattern.compile("\t|\r|\n").matcher(var1).replaceAll("").trim();
   }

   public static JPopupMenu createMenu(ActionListener var0, boolean var1) {
      JPopupMenu var3 = new JPopupMenu("操作方式");
      String var2;
      String var5;
      if (var1) {
         var5 = "清空";
         var2 = "doClear";
      } else {
         var5 = "导出";
         var2 = "doImp";
      }

      JMenuItem var4;
      (var4 = new JMenuItem("按总单" + var5)).setActionCommand("doc_" + var2);
      var4.addActionListener(var0);
      var3.add(var4);
      (var4 = new JMenuItem("按细单" + var5)).setActionCommand("dtl_" + var2);
      var4.addActionListener(var0);
      var3.add(var4);
      return var3;
   }

   private void a(String var1) {
      int[] var2;
      if ((var2 = this.getMasterModel().getTable().getSelectedRows()).length < 0) {
         this.infoMessage("提示", "请选择结算总单导出金穗！");
      } else {
         if (var2.length > 1 && var1.equals("0")) {
            if (JOptionPane.showConfirmDialog(this.getParentFrame(), "界面多选操作，系统将转换成按总单处理，是否继续?", "提示", 2) != 0) {
               return;
            }

            var1 = "1";
         }

         String var3 = null;
         if ("1".equals(var1)) {
            for(int var4 = 0; var4 < var2.length; ++var4) {
               if (this.getMasterModel().getdbStatus(var2[var4]) != 0) {
                  this.infoMessage("提示", "第" + (var2[var4] + 1) + "行总单没有保存不能导出金穗");
                  return;
               }

               var3 = this.getMasterModel().getItemValue(var2[var4], "usestatus");
               if (!"1".equals(var3)) {
                  this.infoMessage("提示", "第" + (var2[var4] + 1) + "行总单不是正式状态，不能按总单导出金穗，请重新确定");
                  return;
               }
            }
         } else {
            var3 = this.getMasterModel().getItemValue(var2[0], "usestatus");
            if (!"1".equals(var3)) {
               this.infoMessage("提示", "不是正式状态，不能导出金穗，请重新确定");
               return;
            }
         }

         int[] var17 = this.getDetailModel().getTable().getSelectedRows();
         if ("0".equals(var1) && var17.length <= 0) {
            this.infoMessage("提示", "请选择结算细单导出金穗！");
         } else {
            var3 = "";
            String var5 = "";
            if ("1".equals(var1)) {
               HashSet var6 = new HashSet();
               HashSet var7 = new HashSet();

               for(int var8 = 0; var8 < var2.length; ++var8) {
                  var3 = this.getMasterModel().getItemValue(var2[var8], "customid");
                  var6.add(var3);
                  if (var6.size() > 1) {
                     this.errorMessage("错误", "多选操作，必须选择相同的客户！");
                     return;
                  }

                  if ((var5 = this.getMasterModel().getItemValue(var2[var8], "infoid")) != null && !"".equals(var5)) {
                     var7.add(var5);
                     if (var7.size() > 1) {
                        this.errorMessage("错误", "多选操作，必须选择相同的客户发票信息！");
                        return;
                     }
                  }
               }
            } else {
               var3 = this.getMasterModel().getItemValue(var2[0], "customid");
               var5 = this.getMasterModel().getItemValue(var2[0], "infoid");
            }

            boolean var21 = false;
            if (var5 == null || var5.equals("")) {
               String var24 = "select count(*) infocount from bms_sa_inv_info where companyid = " + var3;
               RemotesqlHelper var27 = new RemotesqlHelper();

               int var22;
               try {
                  var22 = Integer.parseInt(var27.doSelect(var24, 0, 1).getItemValue(0, "infocount"));
               } catch (Exception var10) {
                  this.errorMessage("错误", var10.getMessage());
                  var10.printStackTrace();
                  return;
               }

               if (var22 == 0) {
                  this.infoMessage("提示", "客户:" + this.getMasterModel().getItemValue(var2[0], "customname") + ",没有定义销售发票信息,请定义客户销售发票信息后再导出!");
                  return;
               }

               if (var22 == 1) {
                  var24 = "select infoid from bms_sa_inv_info where companyid = " + var3;

                  try {
                     var5 = var27.doSelect(var24, 0, 1).getItemValue(0, "infoid");
                  } catch (Exception var9) {
                     this.errorMessage("错误", var9.getMessage());
                     var9.printStackTrace();
                     return;
                  }
               } else {
                  DBTableModel var18;
                  if ((var18 = (new Bms_sa_inv_info_hov()).showDialog((Frame)null, "选择客户发票", "companyid", var3, " companyid = " + var3)) == null) {
                     return;
                  }

                  var5 = var18.getItemValue(0, "infoid");
               }
            }

            JFileChooser var29;
            if ((var29 = new JFileChooser()).showSaveDialog(this.getParentFrame()) == 0) {
               File var26;
               if (!(var26 = var29.getSelectedFile()).getName().toLowerCase().endsWith(".txt")) {
                  var26 = new File(var26.getParentFile(), var26.getName() + ".txt");
               }

               ClientRequest var23;
               (var23 = new ClientRequest()).addCommand(new StringCommand("Bms_sa_set_mde.导出金穗"));
               var23.addCommand(new StringCommand(var1));
               var23.addCommand(new StringCommand(var5));
               ParamCommand var19 = new ParamCommand();
               int var25;
               if ("1".equals(var1)) {
                  for(var25 = 0; var25 < var2.length; ++var25) {
                     var19.addParam("sasettleid_" + var25, this.getMasterModel().getItemValue(var2[var25], "sasettleid"));
                  }
               } else {
                  if (!"0".equals(var1)) {
                     this.errorMessage("提示", "错误的命令标识！");
                     return;
                  }

                  for(var25 = 0; var25 < var17.length; ++var25) {
                     var19.addParam("sasettledtlid_" + var25, this.getDetailModel().getItemValue(var17[var25], "sasettledtlid"));
                  }
               }

               var23.addCommand(var19);
               var23.addCommand(new StringCommand(this.getMasterModel().getItemValue(var2[0], "sasettleid")));

               try {
                  StringCommand var13;
                  ServerResponse var28;
                  if (!(var13 = (StringCommand)(var28 = SendHelper.sendRequest(var23)).commandAt(0)).getString().startsWith("+OK")) {
                     this.errorMessage("错误", var13.getString());
                  } else {
                     String var14 = ((StringCommand)var28.commandAt(1)).getString();
                     FileOutputStream var20 = new FileOutputStream(var26);
                     byte[] var15 = var14.getBytes("GBK");
                     var20.write(var15);
                     var20.close();
                     this.infoMessage("提示", "导出金穗成功！");
                     int var12;
                     if ("1".equals(var1)) {
                        var12 = this.getDetailModel().getRowCount();

                        for(int var16 = 0; var16 < var12; ++var16) {
                           this.getDetailModel().setItemValue(var16, "taxflag", "1");
                           this.getDetailModel().setdbStatus(var16, 0);
                        }

                     } else {
                        for(var12 = 0; var12 < var17.length; ++var12) {
                           this.getDetailModel().setItemValue(var17[var12], "taxflag", "1");
                           this.getDetailModel().setdbStatus(var17[var12], 0);
                        }

                     }
                  }
               } catch (Exception var11) {
                  this.errorMessage("错误", var11.getMessage());
                  var11.printStackTrace();
               }
            }
         }
      }
   }

   private void b() {
      int var1;
      if ((var1 = this.getMasterModel().getRow()) >= 0) {
         int[] var2;
         if ((var2 = this.getDetailModel().getTable().getSelectedRows()).length > 0) {
            String var21 = this.getMasterModel().getItemValue(var1, "usestatus");
            if ("0".equals(var21)) {
               this.infoMessage("提示", "单据是作废状态，不能生成传票！");
            } else {
               String var3;
               for(var1 = 0; var1 < var2.length; ++var1) {
                  var3 = this.getDetailModel().getItemValue(var2[var1], "invalidflag");
                  if ("1".equals(var3)) {
                     this.infoMessage("提示", "单据是作废状态，不能生成传票！");
                     return;
                  }
               }

               boolean var22 = false;

               String var4;
               for(int var23 = 0; var23 < var2.length; ++var23) {
                  if ((var4 = this.getDetailModel().getItemValue(var2[var23], "invno")) != null && !var4.equals("")) {
                     var22 = true;
                  }
               }

               if (!var22 || JOptionPane.showConfirmDialog(this.getParentFrame(), "细单中已有发票号，是否覆盖？") == 0) {
                  var4 = null;
                  CreateInvnoDialog var25;
                  if ("1".equals(this.getApvalue("发票号是否自动递增生成"))) {
                     var21 = ClientUserManager.getCurrentUser().getUserid();
                     var3 = ClientUserManager.getCurrentUser().getRoleid();
                     String var5 = null;
                     RemotesqlHelper var6 = null;
                     String var7 = null;
                     String var8 = null;
                     var7 = null;
                     var5 = "select a.empidset,a.setid ,a.invoicelen,a.curinvoiceno,a.invoicecode from bms_invoice_no_set_v a where a.EMPIDSET is not null";
                     RemotesqlHelper var9 = new RemotesqlHelper();
                     DBTableModel var10 = null;

                     try {
                        var10 = var9.doSelect(var5, 0, 10000);
                     } catch (Exception var20) {
                        var20.printStackTrace();
                     }

                     boolean var11 = false;
                     int var12;
                     String var28;
                     int var34;
                     if (!(var10 != null & var10.getRowCount() > 0)) {
                        try {
                           var5 = "select a.empidset,a.setid,a.invoicelen,a.curinvoiceno,a.invoicecode from bms_invoice_no_set_v a where a.EMPIDSET is null and a.roleidset is not null";
                           var10 = var9.doSelect(var5, 0, 10000);
                        } catch (Exception var16) {
                           var16.printStackTrace();
                        }

                        if (var10 != null && !"".equals(var10)) {
                           var34 = var10.getRowCount();

                           for(var12 = 0; var12 < var34; ++var12) {
                              var4 = var10.getItemValue(var12, "setid");
                              var28 = var10.getItemValue(var12, "roleidset");
                              var10.getItemValue(var12, "invoicelen");
                              var8 = var10.getItemValue(var12, "curinvoiceno");
                              var7 = var10.getItemValue(var12, "invoicecode");
                              var5 = "select count(1) count from dual where '" + var3 + "' in(" + var28 + ")";

                              try {
                                 var10 = var9.doSelect(var5, 0, 10000);
                              } catch (Exception var15) {
                                 var15.printStackTrace();
                              }

                              if (Integer.parseInt(var10.getItemValue(0, "count")) == 1) {
                                 break;
                              }

                              var4 = null;
                           }

                           if (var4 == null || "".equals(var4)) {
                              this.infoMessage("提示", "没有找到当前人员的发票设置，不能自动生成请到发票设置功能进行设置");
                              return;
                           }
                        } else {
                           this.infoMessage("提示", "没有找到当前人员的发票设置，不能自动生成请到发票设置功能进行设置");
                        }
                     } else {
                        var34 = var10.getRowCount();

                        for(var12 = 0; var12 < var34; ++var12) {
                           var4 = var10.getItemValue(var12, "setid");
                           var5 = var10.getItemValue(var12, "empidset");
                           var7 = var10.getItemValue(var12, "invoicelen");
                           int var27 = (var8 = var10.getItemValue(var12, "curinvoiceno")).length();
                           if (var8.length() < Integer.parseInt(var7)) {
                              for(int var13 = 0; var13 < Integer.parseInt(var7) - var27; ++var13) {
                                 var8 = "0" + var8;
                              }
                           }

                           var7 = var10.getItemValue(var12, "invoicecode");
                           DBTableModel var35 = null;
                           var6 = new RemotesqlHelper();

                           try {
                              var5 = "select count(1) count from dual where " + var21 + " in(" + var5 + ")";
                              var35 = var6.doSelect(var5, 0, 10000);
                           } catch (Exception var19) {
                              var19.printStackTrace();
                           }

                           if (Integer.parseInt(var35.getItemValue(0, "count")) == 1) {
                              break;
                           }

                           var4 = null;
                        }

                        if (var4 == null || "".equals(var4)) {
                           try {
                              var5 = "select a.empidset,a.setid ,a.invoicelen,a.curinvoiceno,a.invoicecode from bms_invoice_no_set_v a where a.EMPIDSET is null and a.roleidset is not null";
                              var10 = var9.doSelect(var5, 0, 10000);
                           } catch (Exception var18) {
                              var18.printStackTrace();
                           }

                           if (var10 != null && !"".equals(var10)) {
                              var34 = var10.getRowCount();

                              for(var12 = 0; var12 < var34; ++var12) {
                                 var4 = var10.getItemValue(var12, "setid");
                                 var28 = var10.getItemValue(var12, "roleidset");
                                 var10.getItemValue(var12, "invoicelen");
                                 var8 = var10.getItemValue(var12, "curinvoiceno");
                                 var7 = var10.getItemValue(var12, "invoicecode");
                                 var5 = "select count(1) count from dual where '" + var3 + "' in(" + var28 + ")";

                                 try {
                                    var10 = var9.doSelect(var5, 0, 10000);
                                 } catch (Exception var17) {
                                    var17.printStackTrace();
                                 }

                                 if (Integer.parseInt(var10.getItemValue(0, "count")) == 1) {
                                    break;
                                 }

                                 var4 = null;
                              }

                              if (var4 == null || "".equals(var4)) {
                                 this.infoMessage("提示", "没有找到当前人员的发票设置，不能自动生成请到发票设置功能进行设置");
                                 return;
                              }
                           } else {
                              this.infoMessage("提示", "没有找到当前人员的发票设置，不能自动生成请到发票设置功能进行设置");
                           }
                        }
                     }

                     (var25 = new CreateInvnoDialog(this.frame, "生成销售发票", (COtherquerycontrol)null, var8, var7)).pack();
                     var25.setVisible(true);
                  } else {
                     (var25 = new CreateInvnoDialog(this.frame, "生成销售发票", (COtherquerycontrol)null)).pack();
                     var25.setVisible(true);
                  }

                  if (var25.isConfirm()) {
                     ParamCommand var24 = new ParamCommand();
                     var25.setParamValue(var24);
                     ClientRequest var26;
                     (var26 = new ClientRequest()).addCommand(new StringCommand("生成发票信息"));
                     ParamCommand var29 = new ParamCommand();
                     ParamCommand var30 = new ParamCommand();
                     var26.addCommand(new StringCommand("bms_sa_settle_dtl"));

                     int var31;
                     for(var31 = 0; var31 < var2.length; ++var31) {
                        var29.addParam("ID_" + var31, "sasettledtlid = " + this.getDetailModel().getItemValue(var2[var31], "sasettledtlid"));
                     }

                     for(var31 = 0; var31 < var2.length; ++var31) {
                        if ("1".equals(this.getApvalue("发票号是否自动递增生成"))) {
                           var30.addParam("invflag", "1");
                           var30.addParam("setid_" + var31, var4);
                        } else {
                           var30.addParam("invflag", "0");
                        }
                     }

                     var26.addCommand(var29);
                     var26.addCommand(var24);
                     var26.addCommand(var30);
                     ServerResponse var33 = null;

                     try {
                        var33 = SendHelper.sendRequest(var26);
                     } catch (Exception var14) {
                        var14.printStackTrace();
                     }

                     StringCommand var32;
                     if (!(var32 = (StringCommand)var33.commandAt(0)).getString().startsWith("+OK")) {
                        this.infoMessage("提示", "生成销售发票失败!原因为：" + var32.getString());
                     } else {
                        for(var31 = 0; var31 < var2.length; ++var31) {
                           this.getDetailModel().setItemValue(var2[var31], "invdate", var24.getValue("invdate"));
                           this.getDetailModel().setItemValue(var2[var31], "invno", var24.getValue("invno"));
                           this.getDetailModel().setItemValue(var2[var31], "invcode", var24.getValue("invcode"));
                           this.getDetailModel().setdbStatus(var2[var31], 0);
                        }

                        this.infoMessage("提示", "生成销售发票成功!");
                     }
                  }
               }
            }
         }
      }
   }

   private void a(boolean var1) {
      int var2;
      if ((var2 = this.getMasterModel().getRow()) >= 0) {
         if (var2 != this.getMasterModel().getDBtableModel().getRowCount()) {
            int var3;
            for(var3 = 0; var3 < this.getMasterModel().getRowCount(); ++var3) {
               if (this.getMasterModel().getdbStatus(var3) != 0) {
                  this.errorMessage("错误", "没有保存不能确定,请先保存!");
                  return;
               }
            }

            int[] var16;
            if ((var16 = this.getMasterModel().getTable().getSelectedRows()).length <= 0) {
               this.infoMessage("", "请先选择需要确定的结算单！");
            } else {
               String var6;
               for(int var4 = 0; var4 < var16.length; ++var4) {
                  String var5 = this.getMasterModel().getItemValue(var16[var4], "settletypeid");
                  if ("1".equals(var5)) {
                     var6 = this.detailmodel.getItemValue(this.detailmodel.getRow(), "ephedrine");
                     if ("1".equals(var6)) {
                        this.errorMessage("错误", "细单中有麻黄碱类药品，不允许现金结账！");
                        return;
                     }
                  }
               }

               String var18 = "0";
               DBTableModel var19 = d();

               int var24;
               for(var24 = 0; var24 < var16.length; ++var24) {
                  if (!"2".equals(this.getMasterModel().getItemValue(var16[var24], "usestatus"))) {
                     this.errorMessage("错误", "该销售结算单已确定或已被作废！");
                     return;
                  }

                  var19.appendRow();
                  var19.setItemValue(var19.getRowCount() - 1, "sasettleid", this.getMasterModel().getItemValue(var16[var24], "sasettleid"));
                  var19.setItemValue(var19.getRowCount() - 1, "allowfix", this.getApvalue("确定后准许出库配货"));
                  var19.setItemValue(var19.getRowCount() - 1, "autofix", this.getApvalue("确定后自动出库配货"));
                  var19.setItemValue(var19.getRowCount() - 1, "autokeep", this.getApvalue("确定后自动记保管账"));
                  String var7 = this.getMasterModel().getItemValue(var16[var24], "total");
                  var18 = DecimalHelper.add(var18, var7, 2);
               }

               DataCommand var26 = new DataCommand();
               String var17 = "";
               HashSet var20 = new HashSet();

               for(int var8 = 0; var8 < this.getDetailModel().getRowCount(); ++var8) {
                  String var9 = this.getDetailModel().getItemValue(var8, "salerid");
                  var20.add(var9);
               }

               Iterator var28;
               for(var28 = var20.iterator(); var28.hasNext(); var17 = var17 + (String)var28.next() + ",") {
               }

               boolean var30 = false;
               if (var19 != null && var19.getRowCount() > 1) {
                  if (JOptionPane.showConfirmDialog(this.frame, "您现在进行的是批量确定操作，批量确定不支持现生成发票和现结，是否继续?", "提示", 0) != 0) {
                     return;
                  }

                  var30 = true;
               }

               String var14;
               if (!var30) {
                  if (DecimalHelper.toDec(var18).compareTo(BigDecimal.ZERO) != 0) {
                     Bms_sa_set_confirm_hov var21;
                     (var21 = new Bms_sa_set_confirm_hov()).setHaveEphedirne(this.a(this.mastermodel.getRow()));
                     var21.setMoney(var18);
                     var21.setSalerids(var17);
                     var17 = this.getMasterModel().getItemValue(var2, "customid");
                     if ((var6 = this.getMasterModel().getItemValue(var2, "agentid")).equals("") || var6 == null) {
                        var6 = "-1";
                     }

                     String var29 = this.getMasterModel().getItemValue(var2, "entryid");
                     var14 = this.getMasterModel().getItemValue(var2, "fmid");
                     var17 = "customid = " + var17 + " and entryid = " + var29 + " and nvl(agentid,-1)=" + var6;
                     if (var14.length() > 0) {
                        var17 = var17 + " and fmid = " + var14;
                     }

                     if (var21.showDialog(this.frame, "立即收款", "settletypeid", "%", var17) == null) {
                        return;
                     }

                     DBTableModel var23 = var21.getTablemodel();
                     var26.setDbmodel(var23);
                  } else {
                     var26.setDbmodel(d());
                  }
               } else {
                  var26.setDbmodel(new DBTableModel());
               }

               ClientRequest var25 = new ClientRequest();
               StringCommand var22 = new StringCommand("Bms_sa_set_mde.销售结算单确定");
               DataCommand var27;
               (var27 = new DataCommand()).setDbmodel(var19);
               var25.addCommand(var22);
               var25.addCommand(var27);
               var25.addCommand(var26);
               this.setWaitCursor();
               var25.addCommand(new StringCommand(this.getEntryid()));
               var25.addCommand(new StringCommand(String.valueOf(var1)));
               var28 = null;

               try {
                  ServerResponse var31 = SendHelper.sendRequest(var25);
                  var14 = this.a(var31, "确定", 2, 5, 1);
                  if (!"1".equals(var14)) {
                     return;
                  }
               } catch (Exception var12) {
                  this.errorMessage("错误", "确定不成功原因:" + var12.getMessage());
                  var12.printStackTrace();
               } finally {
                  this.setDefaultCursor();
               }

               if (!var30) {
                  boolean var15 = false;
                  var3 = this.getDetailModel().getRowCount();

                  for(var24 = 0; var24 < this.getDetailModel().getRowCount(); ++var24) {
                     if ((var18 = this.getDetailModel().getItemValue(var24, "invno")) == null || var18.equals("")) {
                        var15 = true;
                     }
                  }

                  if (var15) {
                     if (JOptionPane.showConfirmDialog(this.getParentFrame(), "细单中没有发票号，是否生成发票号？") != 0) {
                        return;
                     }

                     this.getDetailModel().getTable().setRowSelectionInterval(0, var3);
                     this.b();
                  }
               }

            }
         }
      }
   }

   private void c() {
      int var1;
      if ((var1 = this.getMasterModel().getRow()) >= 0 && var1 != this.getMasterModel().getDBtableModel().getRowCount()) {
         for(int var2 = 0; var2 < this.getMasterModel().getRowCount(); ++var2) {
            if (this.getMasterModel().getdbStatus(var2) != 0) {
               this.errorMessage("错误", "没有保存不能作废,请先保存!");
               return;
            }
         }

         if (this.getDetailModel().getRow() >= 0) {
            if (this.getDetailModel().getRow() != this.getDetailModel().getDBtableModel().getRowCount()) {
               int[] var15;
               int var3 = (var15 = this.getDetailModel().getTable().getSelectedRows()).length;
               if (this.getDetailModel().getTable().getSelectedRow() == this.getDetailModel().getTable().getRowCount() - 1) {
                  this.errorMessage("错误", "选中行错误,请重新选择!");
               } else {
                  if (var15[var15.length - 1] == this.getDetailModel().getRowCount()) {
                     --var3;
                  }

                  String var14 = this.getMasterModel().getItemValue(var1, "sasettleid");
                  Vector var4 = new Vector();
                  DBColumnDisplayInfo var5 = new DBColumnDisplayInfo("sasettledtlid", "number");
                  var4.add(var5);
                  var5 = new DBColumnDisplayInfo("message", "varchar");
                  var4.add(var5);
                  var5 = new DBColumnDisplayInfo("sasettleid", "number");
                  var4.add(var5);
                  var5 = new DBColumnDisplayInfo("usestatus", "number");
                  var4.add(var5);
                  var5 = new DBColumnDisplayInfo("invalidflag", "number");
                  var4.add(var5);
                  var5 = new DBColumnDisplayInfo("invalidmanid", "number");
                  var4.add(var5);
                  var5 = new DBColumnDisplayInfo("invalidmanname", "varchar");
                  var4.add(var5);
                  var5 = new DBColumnDisplayInfo("invalidtime", "date");
                  var4.add(var5);
                  var5 = new DBColumnDisplayInfo("goodsqty", "date");
                  var4.add(var5);
                  var5 = new DBColumnDisplayInfo("unitprice", "date");
                  var4.add(var5);
                  var5 = new DBColumnDisplayInfo("total_line", "date");
                  var4.add(var5);
                  var5 = new DBColumnDisplayInfo("taxmoney", "date");
                  var4.add(var5);
                  var5 = new DBColumnDisplayInfo("notaxmoney", "date");
                  var4.add(var5);
                  var5 = new DBColumnDisplayInfo("shoulesettlemoney", "date");
                  var4.add(var5);
                  var5 = new DBColumnDisplayInfo("dtl_lines", "number");
                  var4.add(var5);
                  var5 = new DBColumnDisplayInfo("total", "number");
                  var4.add(var5);
                  DBTableModel var16 = new DBTableModel(var4);

                  String var6;
                  for(int var19 = 0; var19 < var3; ++var19) {
                     if (this.getDetailModel().getdbStatus(var15[var19]) != 0) {
                        this.errorMessage("错误", "第" + (var15[var19] + 1) + "行细单没有保存不能作废,请先保存!");
                        return;
                     }

                     var6 = this.getDetailModel().getItemValue(var15[var19], "correctflag");
                     if ("".equals(var6)) {
                        var6 = "0";
                     }

                     if (!var6.equals("0")) {
                        this.errorMessage("错误", "原单、冲单、新单不允许作废，请检查第" + (var15[var19] + 1) + "行细单！");
                        return;
                     }

                     var6 = this.getDetailModel().getItemValue(var15[var19], "sasettledtlid");

                     try {
                        if (NpSaDbHelper.setHaveBeenRec(var6)) {
                           this.errorMessage("错误", "第" + (var15[var19] + 1) + "行细单已收款,不能作废！");
                           return;
                        }
                     } catch (Exception var13) {
                        this.infoMessage("提示", var13.getMessage());
                        var13.printStackTrace();
                        return;
                     }

                     int var7 = var16.getRowCount();
                     var16.appendRow();
                     var16.setItemValue(var7, "sasettleid", var14);
                     var16.setItemValue(var7, "sasettledtlid", var6);
                  }

                  if (var16.getRowCount() > 0) {
                     ClientRequest var20 = new ClientRequest();
                     DataCommand var17;
                     (var17 = new DataCommand()).setDbmodel(var16);
                     var20.addCommand(new StringCommand("Bms_sa_set_mde.销售结算单作废"));
                     var20.addCommand(var17);
                     this.setWaitCursor();
                     var6 = null;

                     try {
                        ServerResponse var18 = SendHelper.sendRequest(var20);
                        this.a(var18, "作废");
                        return;
                     } catch (Exception var11) {
                        var11.printStackTrace();
                        this.errorMessage("错误", "作废不成功,原因:" + var11.getMessage());
                     } finally {
                        this.setDefaultCursor();
                     }

                  }
               }
            }
         }
      }
   }

   private String a(ServerResponse var1, String var2, int var3, int var4, int var5) {
      String var6;
      if (!(var6 = var1.getCommand()).startsWith("+OK") && !var6.equals("Again")) {
         this.errorMessage("错误", var6);
         return "0";
      } else {
         DBTableModel var7 = this.getMasterModel().getDBtableModel();
         String var8 = "sasettleid";
         if (var5 == 0) {
            var7 = this.getDetailModel().getDBtableModel();
            var8 = "sasettledtlid";
         }

         DBTableModel var13 = ((DataCommand)var1.commandAt(1)).getDbmodel();

         for(var5 = 0; var5 < var13.getRowCount(); ++var5) {
            String var9 = var13.getItemValue(var5, var8);
            String var10 = var13.getItemValue(var5, "message");

            for(int var11 = 0; var11 < var7.getRowCount(); ++var11) {
               if (var7.getItemValue(var11, var8).equals(var9)) {
                  if (!var10.startsWith("+OK")) {
                     var7.getRecordThunk(var11).setSaveresult(1, var10);
                     break;
                  }

                  for(int var14 = var3; var14 <= var4; ++var14) {
                     var10 = var13.getColumnDBName(var14);
                     var7.setItemValue(var11, var10, var13.getItemValue(var5, var10));
                  }

                  var7.setdbStatus(var11, 0);
                  var7.getRecordThunk(var11).setSaveresult(0, var2 + "成功");
                  break;
               }
            }
         }

         this.getMasterModel().tableChanged();
         this.getDetailModel().tableChanged();
         if (var6.equals("Again") && JOptionPane.showConfirmDialog(this.frame, "结算价格应高于批发最低限价，低于国家零售价\n是否继续？") == 0) {
            this.a(false);
         }

         return "1";
      }
   }

   private void a(ServerResponse var1, String var2) {
      String var3;
      if ((var3 = var1.getCommand()).startsWith("+OK")) {
         this.a(var1, var2, 4, 13, 0);
         DBTableModel var8;
         int var9 = (var8 = ((DataCommand)var1.commandAt(1)).getDbmodel()).getRowCount() - 1;
         var3 = var8.getItemValue(var9, "sasettleid");
         String var4 = var8.getItemValue(var9, "message");
         DBTableModel var5 = this.getMasterModel().getDBtableModel();

         for(int var6 = 0; var6 < var5.getRowCount(); ++var6) {
            if (var5.getItemValue(var6, "sasettleid").equals(var3) && var4.startsWith("+OK")) {
               var5.setItemValue(var6, "usestatus", var8.getItemValue(var9, "usestatus"));
               var5.setItemValue(var6, "dtl_lines", var8.getItemValue(var9, "dtl_lines"));
               var5.setItemValue(var6, "total", var8.getItemValue(var9, "total"));
               var5.setdbStatus(var6, 0);
               this.getMasterModel().tableChanged();
               return;
            }
         }

      } else {
         this.errorMessage("错误", var3);
      }
   }

   private static DBTableModel d() {
      Vector var0 = new Vector();
      DBColumnDisplayInfo var1 = new DBColumnDisplayInfo("sasettleid", "number");
      var0.add(var1);
      var1 = new DBColumnDisplayInfo("message", "varchar");
      var0.add(var1);
      var1 = new DBColumnDisplayInfo("usestatus", "number");
      var0.add(var1);
      var1 = new DBColumnDisplayInfo("confirmmanid", "number");
      var0.add(var1);
      var1 = new DBColumnDisplayInfo("confirmmanname", "varchar");
      var0.add(var1);
      var1 = new DBColumnDisplayInfo("confirmdate", "date");
      var0.add(var1);
      var1 = new DBColumnDisplayInfo("allowfix", "number");
      var0.add(var1);
      var1 = new DBColumnDisplayInfo("autofix", "number");
      var0.add(var1);
      var1 = new DBColumnDisplayInfo("autokeep", "number");
      var0.add(var1);
      return new DBTableModel(var0);
   }

   private void b(String var1) {
      int[] var2;
      if ((var2 = this.getMasterModel().getTable().getSelectedRows()).length < 0) {
         this.infoMessage("提示", "请选择结算总单清空标志！");
      } else {
         if (var2.length > 1 && var1.equals("0")) {
            if (JOptionPane.showConfirmDialog(this.getParentFrame(), "界面多选操作，系统将转换成按总单处理，是否继续?", "提示", 2) != 0) {
               return;
            }

            var1 = "1";
         }

         int[] var3 = this.getDetailModel().getTable().getSelectedRows();
         if ("0".equals(var1) && var3.length <= 0) {
            this.infoMessage("提示", "请选择结算细单");
         } else {
            ParamCommand var4 = new ParamCommand();
            String var5;
            int var6;
            if ("1".equals(var1)) {
               var5 = null;

               for(var6 = 0; var6 < var2.length; ++var6) {
                  var5 = this.getMasterModel().getItemValue(var2[var6], "sasettleid");
                  var4.addParam("sasettleid_" + var6, var5);
               }
            } else {
               if (!"0".equals(var1)) {
                  this.errorMessage("错误", "错误的命令标识");
                  return;
               }

               var5 = null;

               for(var6 = 0; var6 < var3.length; ++var6) {
                  var5 = this.getDetailModel().getItemValue(var3[var6], "sasettledtlid");
                  var4.addParam("sasetdtlid_" + var6, var5);
               }
            }

            ClientRequest var10;
            (var10 = new ClientRequest()).addCommand(new StringCommand("Bms_sa_set_mde.清除导出标志"));
            var10.addCommand(new StringCommand(var1));
            var10.addCommand(var4);
            Object var11 = null;

            try {
               StringCommand var9;
               if (!(var9 = (StringCommand)SendHelper.sendRequest(var10).commandAt(0)).getString().startsWith("+OK")) {
                  this.infoMessage("提示", "清除导出标志失败！" + var9.getString());
               } else {
                  int var8;
                  if ("1".equals(var1)) {
                     for(var8 = 0; var8 < this.getDetailModel().getRowCount(); ++var8) {
                        this.getDetailModel().setItemValue(var8, "taxflag", "0");
                        this.getDetailModel().setdbStatus(var8, 0);
                     }
                  } else {
                     for(var8 = 0; var8 < var3.length; ++var8) {
                        this.getDetailModel().setItemValue(var3[var8], "taxflag", "0");
                        this.getDetailModel().setdbStatus(var3[var8], 0);
                     }
                  }

                  this.infoMessage("提示", "清除导出标志成功！");
               }
            } catch (Exception var7) {
               var7.printStackTrace();
               this.infoMessage("警告", "发送服务器命令：Bms_sa_set_mde.清除导出标志  错误");
            }
         }
      }
   }

   protected a doTickSte(int var1, String var2, String var3) {
      this.d = new Bms_sa_tick_hov();
      Bms_sa_tick_hov var4;
      (var4 = (Bms_sa_tick_hov)this.d).setFmid(this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "fmid"));
      var4.setExchange(this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "exchange"));
      String var5 = this.getEntryid();
      String var6;
      if ((var6 = this.getMasterModel().getItemValue(var1, "agentid")).equals("") || var6 == null) {
         var6 = "-1";
      }

      var6 = "customid = " + var2 + " and sa_mode = " + var3 + " and entryid = " + var5 + " and abs(settleqty) < abs(goodsqty)  and nvl(agentid,-1)=" + var6;
      DBTableModel var8 = var4.showDialog(this.frame, "由销售发货单生成", "settletypeid", "%", var6);
      a var7;
      (var7 = new a(this)).a = var8;
      var7.b = var4.isext;
      return var7;
   }

   protected a doTickMde(int var1, String var2, String var3) {
      this.d = new Bms_sa_tick_mde_hov();
      Bms_sa_tick_mde_hov var4;
      (var4 = (Bms_sa_tick_mde_hov)this.d).setFmid(this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "fmid"));
      var4.setExchange(this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "exchange"));
      String var5 = this.getEntryid();
      String var6;
      if ((var6 = this.getMasterModel().getItemValue(var1, "agentid")).equals("") || var6 == null) {
         var6 = "-1";
      }

      var6 = "customid = " + var2 + " and sa_mode = " + var3 + " and entryid = " + var5 + " and nvl(agentid,-1)=" + var6;
      DBTableModel var8 = this.d.showDialog(this.frame, "由销售发货单生成", "settletypeid", "%", var6);
      a var7;
      (var7 = new a(this)).a = var8;
      var7.b = var4.isext;
      var7.c = true;
      return var7;
   }

   protected int on_beforesave() {
      for(int var1 = 0; var1 < this.getDetailModel().getRowCount(); ++var1) {
         if (this.getDetailModel().getdbStatus(var1) == 3) {
            this.c = true;
         }
      }

      return super.on_beforesave();
   }

   protected void on_save() {
      super.on_save();
      if (this.c) {
         this.c = false;
      } else {
         boolean var1 = false;
         int var2 = this.getDetailModel().getRowCount();

         for(int var3 = 0; var3 < this.getDetailModel().getRowCount(); ++var3) {
            String var4;
            if ((var4 = this.getDetailModel().getItemValue(var3, "invno")) == null || var4.equals("")) {
               var1 = true;
            }
         }

         if (var1) {
            if (JOptionPane.showConfirmDialog(this.getParentFrame(), "细单中没有发票号，是否生成发票号？") != 0) {
               return;
            }

            this.getDetailModel().getTable().setRowSelectionInterval(0, var2);
            this.b();
         }

      }
   }

   private boolean a(int var1) {
      boolean var2 = false;
      DBTableModel var5;
      if ((var5 = this.getDetaildbmodel(var1)) == null) {
         return true;
      } else {
         int var3 = var5.getRowCount();

         for(int var4 = 0; var4 < var3; ++var4) {
            if ("1".equals(var5.getItemValue(var4, "ephedrine"))) {
               var2 = true;
               break;
            }
         }

         return var2;
      }
   }

   class a {
      DBTableModel a;
      boolean b = false;
      boolean c = false;

      a(Bms_sa_set_mde var1) {
      }
   }
}
